import time
import paragonwl

from Commonfunctions import FALSE,TRUE 

class  Measurement:
    #variable paragonObject port1 port2 references master slave
    
	def __init__(self,paragonObject1):
		self.par1 = paragonObject1


		# Selecting Operating mode, 1588v2, Enable Master / Slave Emulation
		self.par1.paragonset("SimulMeasImpairMode","MEASUREONLY")  
		self.par1.paragonset("OperatingMode",  "PTP")
		self.par1.paragonset("MasterSlave Enabled", "TRUE")		
		# Choosing test Configuration
		self.par1.paragonset( "MasterSlave TestConfiguration",  "BOUNDARY_CLOCK")


		# Always uncouple the interfaces
		self.par1.paragonset("Physical Coupled", "FALSE")
		self.port1 = Port (self.par1, self , 0)
		self.port2 = Port (self.par1, self , 1)
		self.references = References (self.par1 , self )
		self.master = Master ( self.par1, self)
		self.slave  = Slave (self.par1, self)
			#set port1 [ Port new $par1 [self] 0]
			#set port2 [ Port new $par1 [self] 1]
			#set references [ References new $par1 [self] ]
			#set master [ Master new $par1 [self] ]
			#set slave [ Slave new $par1 [self] ]
    
    
		#def __del__():
    
	
	def measurementConfiguration ( self,pdhWander ,onePps, syncE ):
		# Measurements settings 


			try:
				# Catch situation whereby customers do not have Opton 205 (Wander Measurements) enabled
				if pdhWander == "None":
					self.par1.paragonset( "Capture Pdh T1WanderCaptEnable", "FALSE")
					self.par1.paragonset( "Capture Pdh E1WanderCaptEnable", "FALSE")
					self.par1.paragonset( "Capture Pdh M2WanderCaptEnable", "FALSE")
				else:
					self.par1.paragonset( "Capture Pdh %s" % pdhWander, "TRUE")
		    
			except:
				print ("Error")
				#log ( information )
				#log $detailedInformation
				revisit = 1

		
			if onePps == "None":
				self.par1.paragonset( "Capture OnePps AccuracyCaptEnable", "FALSE")
				self.par1.paragonset( "Capture OnePps WanderCaptEnable", "FALSE")
			else:
				self.par1.paragonset( "Capture OnePps %s" % onePps, "TRUE")
		
		
			# SyncE connection
			self.par1.paragonset ("Capture SyncE WanderCaptEnable",  syncE)
		
    
	
    # DJWAT-PX-AE-7
	def portSetLineRate ( self,lineRate ,portNumber):
		if portNumber ==1:
			port = self.port2
		else:
			port = self.port1
		port.setLineRate( lineRate )

	
    # DJWAT-PX-AE-7
	def portSetInterface (self,interface, portNumber):
		if portNumber ==1:
			port = self.port2
		else:
			port = self.port1
		port.setInterface( interface )
    
	
	def portLinkIsUp ( self,portNumber ): 
		status= 'FALSE'
		if portNumber == 1:
			port = self.port2
		else:
			port = self.port1

			# Check the link status. Try for 10 seconds...
		for  i in range(10):
			status = port.getLinkStatus()
			if status == 'TRUE':
				break
			time.sleep(1)	
		return status
	

	def portPacketsReceived ( self,portNumber ):
		status= False
		if portNumber == 1:
			port = self.port2
		else:
			port = self.port1
	
		# Check the packet status. Try for 10 seconds...
		for i in range (10):
			status = port.getPacketStatus()
			if status == True: 
				break
			time.sleep(1)
		
		return status
	
	
	def referencesSetClockSource (self,clock ):
		self.references.setClockSource (clock)
    
	
	def masterSetEncapsulation ( self,encapsulation ): 
		self.master.setEncapsulation ( encapsulation )
	
	
	def masterConfigureMulticast(self):
		self.master.configureMulticast()
	
	
	def masterSetMessagesFrequencies ( self,announce, sync ):
		self.master.setMessagesFrequencies ( announce , sync )
	
	
	def slaveSetEncapsulation ( self,encapsulation ): 
		self.slave.setEncapsulation ( encapsulation )
	
	
	def slaveConfigureMulticast(self):
		self.slave.configureMulticast()
	
	
	def slaveSetAllowedMasters ( self,delReqRate ):
		self.slave.setAllowedMasters (delReqRate)
	

	
	def setCableDelay ( self,cableDelay ):  
		# configure DUT to Paragon-x Cable Delay
		self.par1.paragonset ("MasterSlave BoundaryClockCalibration", str(cableDelay))
	
	


# =================================================================================================

class Port:
        
	#  def __init__(self,paragonObject1,measurement1,portNumber):
	#		self.par1 = paragonObject1
	#		self.measurement = measurement1
	#		self.portId = ("#%d" % portNumber)
	
	def __init__(self, paragonObject1,measurement1,portNumber):	
		self.par1 = paragonObject1
		self.measurement = measurement1
		self.portId = ("#%d" % portNumber)

	#def __del__():
    
	def	setLineRate(self,lineRate):
	# Configuring Line Rate in Setup Interface

		self.par1.paragonset("Physical %s LineRate" %self.portId,str(lineRate))

		# self.par1 paragonset Physical LineRate 1GBE
		# self.par1 paragonset Physical LineRate 100BASET
		# self.par1 paragonset Physical LineRate 10GBE
    
	
	def setInterface ( self,interface ):
	
		if interface == "OPTICAL":
				self.par1.paragonset ("Physical %s LineInterface" % self.portId, str(interface))
		
		if  interface == "ELECTRICAL":
			self.par1.paragonset ("Physical %s LineInterface" % self.portId, str(interface))
		
		if interface == "XFP":
			self.par1.paragonset("Physical %s LineRate" % self.portId, "10GBE")
			self.par1.paragonset("Physical %s xFPSelect" % self.portId, "XFP")
		
		if interface == "SFPPLUS":
			self.par1.paragonset ("Physical %s LineRate" % self.portId, "10GBE")
			self.par1.paragonset ("Physical %s xFPSelect" % self.portId , "SFPPLUS")
		
		# par1 paragonset Physical xFPSelect XFP
		# par1 paragonset Physical xFPSelect SFPPLUS
		# par1 paragonset Physical LineInterface ELECTRICAL
    

	def getLinkStatus(self):
		return (self.par1.paragonget ("InstrumentStatus Interface %s Link Detected" % self.portId))
	
	def	getPacketStatus(self):
		return (self.par1.paragonget ("InstrumentStatus Interface %s RxPackets Good" % self.portId))
	


# =================================================================================================

class References:
 
	def __init__(self,paragonObject1,measurement1):
		self.par1 = paragonObject1
		self.measurement = measurement1
    
	
	#	def __del__ ():
    
	def setClockSource(self,clock):
		# Configure stable reference for Paragon-x, setting the clock
		self.par1.paragonset ("Physical RefClkSource", str (clock))
		
		# par1 paragonset Physical RefClkSource EXT_10M
		# par1 paragonset Physical RefClkSource EXT_R75_E1
		# par1 paragonset Physical RefClkSource EXT_R100_T1
		# par1 paragonset Physical RefClkSource EXT_R100_E1
		# par1 paragonset Physical RefClkSource EXT_K64
		# par1 paragonset Physical RefClkSource INT
    


# =================================================================================================

class MasterSlaveSetUp:
    
	def __init__(self,paragonObject1,measurement1):
		self.par1 = paragonObject1
		self.measurement = measurement1
    
	
	#  def __del__ ():
	



# =================================================================================================

class Master( MasterSlaveSetUp ):

	def __init__(self,par1,measurement):
		self.par1 = par1
	
	#	def __del__ ():
		 
	
	def setEncapsulation(self,encapsulation):
		self.par1.paragonset ("MasterSlave Master #0 Encapsulation", str(encapsulation))
	
	
	def configureMulticast(self):
		self.par1.paragonset ("MasterSlave Master #0 MulticastEnabled", "TRUE")
		self.par1.paragonset ("MasterSlave Master #0 EnableMcastAnnMsgs", "TRUE")
		self.par1.paragonset ("MasterSlave Master #0 MulticastSyncEnabled", "TRUE")
		self.par1.paragonset ("MasterSlave Master #0 MulticastDelRespEnabled", "TRUE")
		#		$par1 paragonset MasterSlave Master #0 UnicastEnabled FALSE
	
	
	def setMessagesFrequencies(self,announce,sync):
		self.par1.paragonset ("MasterSlave Master #0 MulticastAnnRate",  str(announce))
		self.par1.paragonset ("MasterSlave Master #0 MulticastSyncRate", str(sync))
	


# =================================================================================================

class Slave ( MasterSlaveSetUp ):

    
		
	################################
	## DJWAT TO BE ADDED
	##
	#
	# #  plus in constructor			next $paragonObject1 $measurement1
  

    
	def __init__(self,paragonObject1,measurement1):
		self.par1 = paragonObject1
		self.measurement = measurement1

	
	#  def __del__ ():


	def setEncapsulation ( self,encapsulation ): 
		self.par1.paragonset("MasterSlave Slave Encapsulation",  encapsulation )
	
	
	def configureMulticast(self):
		#		$par1 paragonset MasterSlave Slave UnicastAnnounce FALSE
		#		$par1 paragonset MasterSlave Slave UnicastSync FALSE
		#		$par1 paragonset MasterSlave Slave UnicastDelResp FALSE
		self.par1.paragonset("MasterSlave Slave AutoDiscoverMACMulticastMaster", "TRUE")

	
	
	def setAllowedMasters( self,delReqRate ):
		self.par1.paragonset ("MasterSlave Slave DelRespMsgRate", str(delReqRate))
	
	


# =================================================================================================




	

